package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.CompanyType;
import com.izouma.awesomeadmin.service.CompanyTypeService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/companyType")
@RequiresAuthentication
public class CompanyTypeController {

    @Autowired
    private CompanyTypeService companyTypeService;

    /**
    * <p>获取全部记录。</p>
    */
//    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(CompanyType record) {
        List<CompanyType> pp = companyTypeService.getCompanyTypeList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getCompanyType", method = RequestMethod.GET)
    @ResponseBody
    public Result getCompanyType(@RequestParam(required = false, value = "id") String id) {
        CompanyType data = companyTypeService.getCompanyTypeById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(CompanyType record) {
        CompanyType data = companyTypeService.getCompanyType(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, CompanyType record) {
        Map<String, Object> result = new HashMap<>();

        List<CompanyType> pp =companyTypeService.getCompanyTypeByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(CompanyType record) {
        boolean num = companyTypeService.createCompanyType(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateCompanyType(CompanyType record) {
        boolean num = companyTypeService.updateCompanyType(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteCompanyType(@RequestParam(required = true, value = "id") String id) {

        boolean num = companyTypeService.deleteCompanyType(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, CompanyType record) throws Exception {

    List<CompanyType> companyTypes = companyTypeService.getCompanyTypeList(record);


        String sheetName = "company_type";
        String titleName = "公司属性数据表";
        String fileName = "公司属性表";
        int columnNumber = 9;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "属性名" ,   "备注" ,   ""  };
        String[][] dataList = new String[companyTypes.size()][9];

        for (int i = 0; i < companyTypes.size(); i++) {

                        dataList[i][0] = String.valueOf(companyTypes.get(i).getId());
                        dataList[i][1] = String.valueOf(companyTypes.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(companyTypes.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(companyTypes.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(companyTypes.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(companyTypes.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(companyTypes.get(i).getTypeName());
                        dataList[i][7] = String.valueOf(companyTypes.get(i).getRemark());
                        dataList[i][8] = String.valueOf(companyTypes.get(i).getRank());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

